var fdSlider = new Class({
    Implements: [Options,Events],

    options: {
        article: -1,
        cpage: 0
    },

    pages: 0,
    fdSlides: [],
    cpage: 0,
    lpage: 0,
    slidin: 0,


    initialize: function(options) {
        var anum = parseInt($('anum').value);
        var cols = parseInt($('cols').value);
        var rows = parseInt($('rows').value);
        if(anum == undefined) return;
        this.setOptions(options);
        this.pages = Math.ceil(anum / (cols*rows));
        this.lpage = this.pages-1;
        if (this.pages > 1) {
            $('fdportfoliobtnleft').setStyle('visibility', 'visible');
            $('fdportfoliobtnright').setStyle('visibility', 'visible');
        } else {
            $('fdportfoliobtnleft').setStyle('visibility', 'hidden');
            $('fdportfoliobtnright').setStyle('visibility', 'hidden');
        }

        var testClass = new RegExp("(^|\\s)" + 'fdportfoliopage' + "(\\s|$)");
	var tag = tag || "*";
	var elm = document.getElementById('fdportfoliopages');
	var elements = (tag == "*" && elm.all)? elm.all : elm.getElementsByTagName(tag);
	var returnElements = [];
	var current;
	var length = elements.length;
	for(var i=0; i<length; i++){
		current = elements[i];
		if(testClass.test(current.className)){
			returnElements.push(current);
		}
	}
        this.fdSlides = returnElements;
        // this.fdSlides = $$('.fdportfoliopage');
        for(i = 1; i < this.fdSlides.length ; i++){
            $(this.fdSlides[i].id).setStyle('visibility', 'hidden');
        }       
        this._attachEvents();
    },

    _attachEvents: function(){
        this.nextEvent = function(){
            this._next();
        }.bind(this);
        $('fdportfoliobtnright').addEvent('click', this.nextEvent);

        this.prevEvent = function(){
            this._prev();
        }.bind(this);
        $('fdportfoliobtnleft').addEvent('click', this.prevEvent);
    },

    _next: function(){
        var piwidth = parseInt($('piwidth').value);
        var cols = parseInt($('cols').value);
        var rows = parseInt($('rows').value);
        var mycpage = this.cpage;
        var handler = this;
        var myarticle = this.options.article;
        if (this.cpage != this.lpage && this.slidin != 1){
            this.slidin = 1;
            $('fdportfoliopage'+(this.cpage+1)).setStyle('left', piwidth);
            $('fdportfoliopage'+(this.cpage+1)).setStyle('visibility', 'visible');
            $('fdportfoliopage'+this.cpage).tween('left', -piwidth);
            var chain2 = new Fx.Morph('fdportfoliopage'+(this.cpage+1));

            chain2.start({'left':0
            }).chain(function(){
                if (myarticle >= (mycpage+1)*cols*rows && myarticle < (mycpage+2)*cols*rows   ) {
                    handler.openSlide();
                } else {
                    handler.closeSlide();
                }
                this.callChain();
            }).chain(function(){
                $('fdportfoliopage'+mycpage).setStyle('visibility', 'hidden');
                this.slidin = 0;
                this.cpage++;
            }.bind(this));                        
        } else if(this.slidin != 1){ // first page to proceed
            this.slidin = 1;
            $('fdportfoliopage0').setStyle('left', piwidth);
            $('fdportfoliopage0').setStyle('visibility', 'visible');
            $('fdportfoliopage'+this.cpage).tween('left', -piwidth);
            var chain2start = new Fx.Morph('fdportfoliopage0');

            chain2start.start({'left':0
            }).chain(function(){
//                if (this.options.article > (this.cpage+1)*cols*rows && this.cpage <= (this.cpage+2)*cols*rows   )
                if (myarticle < cols*rows) {
                    handler.openSlide();
                } else {
                    handler.closeSlide();
                }
                this.callChain();
            }).chain(function(){
                    $('fdportfoliopage'+mycpage).setStyle('visibility', 'hidden');
                    this.slidin = 0;
                    this.cpage = 0;
                }.bind(this));                        
        }
    },

    _prev: function(){
        var piwidth = parseInt($('piwidth').value);
        var cols = parseInt($('cols').value);
        var rows = parseInt($('rows').value);
        var mycpage = this.cpage;
        var handler = this;
        var myarticle = this.options.article;
        var mylpage = this.lpage;
        if(this.cpage != 0 && this.slidin != 1){
            this.slidin = 1;
            $('fdportfoliopage'+(this.cpage-1)).setStyle('left', -piwidth);
            $('fdportfoliopage'+(this.cpage-1)).setStyle('visibility', 'visible');
            $('fdportfoliopage'+this.cpage).tween('left', piwidth);
            var chain2 = new Fx.Morph('fdportfoliopage'+(this.cpage-1));

            chain2.start({'left':0
            }).chain(function(){
                if (myarticle < (mycpage)*cols*rows && myarticle >= (mycpage-1)*cols*rows   ) {
                    handler.openSlide();
                } else {
                    handler.closeSlide();
                }
                this.callChain();
            }).chain(function(){
                $('fdportfoliopage'+mycpage).setStyle('visibility', 'hidden');
                this.slidin = 0;
                this.cpage--;
            }.bind(this));
        } else if(this.slidin != 1) { // last page to proceed
            this.slidin = 1;
            $('fdportfoliopage'+(this.lpage)).setStyle('left', -piwidth);
            $('fdportfoliopage'+(this.lpage)).setStyle('visibility', 'visible');
            $('fdportfoliopage'+this.cpage).tween('left', piwidth);
            var chain2end = new Fx.Morph('fdportfoliopage'+(this.lpage));

            chain2end.start({'left':0
            }).chain(function(){
                if (myarticle >= mylpage*cols*rows) {
                    handler.openSlide();
                } else {
                    handler.closeSlide();
                }
                this.callChain();
            }).chain(function(){
                $('fdportfoliopage'+mycpage).setStyle('visibility', 'hidden');
                this.slidin = 0;
                this.cpage = this.lpage;
            }.bind(this));
        }
    },

    closeSlide: function(){
        var fdheight = parseInt($('fdheight').value);
        if(this.options.article != -1) {
            // this.options.caller[this.options.article].slideOut();
            $('fdportfolio').morph({
                'height':fdheight+'px'
                });

                $('fdportfoliowrapper').morph({
                    'height':fdheight+'px'
                });
                $('fdportfoliobtnleft').morph({
                'top':fdheight/2
                });
                $('fdportfoliobtnright').morph({
                    'top':fdheight/2
                });
                // this.options.openitem = -1;
            }
    },

    openSlide: function(){
        var fdheight = parseInt($('fdheight').value);
        var dheight = parseInt($('dheight').value);
        if(this.options.article != -1) {
        // Morph the frame
            $('fdportfolio').morph({
                'height':fdheight+10+dheight+'px'
            });

            $('fdportfoliowrapper').morph({
                'height':fdheight+dheight+17+'px'
            });
            $('fdportfoliobtnleft').morph({
                'top':(fdheight+dheight)/2
            });
            $('fdportfoliobtnright').morph({
                'top':(fdheight+dheight)/2
            });
        }
    }
});

